bordersine  equ 0x8100
border_vals equ 0x8200
border_palette equ 0x8221

  org 0x9000
border
  ld hl,border_vals
  ld b,32
  xor a
clear_border_lp
  ld (hl),a
  inc hl
  djnz clear_border_lp
  
sinepos
  ld a,0
  add a,3;4
  ld (sinepos+1),a

  push af
  push af
  push af

  ld de,border_palette
  ld b,12
border_plot_lp1
    ld c,b
    ld h,bordersine/0x100
    ld l,a
    ld l,(hl)
    inc h
    ex de,hl
    ldi
    ex de,hl
    add a,4
  djnz border_plot_lp1

  pop af
  add a,0x80

  ld b,12
border_plot_lp2
    ld c,b
    ld h,bordersine/0x100
    ld l,a
    ld l,(hl)
    inc h
    ex de,hl
    ldi
    ex de,hl
    add a,4
  djnz border_plot_lp2
  
  pop af
  cpl

  ld de,border_palette
  ld b,12
border_plot_lp3
    ld c,b
    ld h,bordersine/0x100
    ld l,a
    ld l,(hl)
    inc h
    ex de,hl
    ldi
    ex de,hl
    sub 4
  djnz border_plot_lp3

  pop af
  add a,0x80
  cpl

  ld b,12
border_plot_lp4
    ld c,b
    ld h,bordersine/0x100
    ld l,a
    ld l,(hl)
    inc h
    ex de,hl
    ldi
    ex de,hl
    sub 4
  djnz border_plot_lp4


  ; wait
  if defined zx128
    ld b,72 ; for 128
  endif
  if defined pentagon
    ld b,223  ; for pentagon
  endif
  if defined scorpion
    ld b,63 ; for scorpion
  endif
pre_border_zzz
  nop
  nop
  nop
  djnz pre_border_zzz
  if not defined pentagon
    nop
    nop
    nop
    nop
  endif


  ld e,32
  ld hl,border_vals  
border_lp
  ld a,(hl)       ; 7
  inc hl          ; 6
  out (254),a     ; 11
  
  if defined zx128
    ld b,14 ; for 128       ; 7
  else
    ld b,13 ; for scorpion and pentagon
  endif
borderzzz
  djnz borderzzz  ; 13*n
  if defined zx128
    inc bc  ; delay for 6T ; for 128
  endif
  if defined pentagon
    nop ; for pentagon
    ld a,0
    nop ; for pentagon
  endif
  
  dec e           ; 4
  jp nz,border_lp ; 10
  xor a
  out (254),a
  
  ld b,3
post_border_zzz
  djnz post_border_zzz

  if defined pentagon
    nop
    nop
    nop
    nop
  endif
  
  ret

