  org 25000

  ; loading bar
  ld hl,0x598a
  ld b,11
loading_bar_lp
  ld (hl),0x20
  inc l
  halt
  djnz loading_bar_lp

  ; test our is-gs-enabled flag at 0xfffe
  ld a,(0xfffe)
  cp 42
  ret nz

  ld hl,packdata
  ld d,h
  ld e,l
  call dehrust
	
	; load GS with MOD data
  ld hl,packdata	; start address
  ld bc,mod_data_length	; length

gs_data_lp:
  ld a,(hl)
  out (0xb3),a		; output byte to GS
ack4: in a,(0xbb) ; wait for acknowledgement
  rlca
  jr c,ack4
  inc hl		; next address
  dec bc
  ld a,b
  or c			; loop until bc=0
  jp nz,gs_data_lp
  ld a,0xd2 ; command D2: close stream
  out (0xbb),a
ack5  in a,(0xbb)
  rrca
  jr c,ack5
  
  ret

	include dehrust.asm

packdata	incbin mod_data_2.bin.hr
