  org 0x9100

attrdata  equ 0x8280

paint_frame:
	ld (sp_back + 1),sp

  ld bc,1
frame_wait:
	dec bc	
	ld a,b	
	or c	
	jr nz,frame_wait

	ld a,0
	out (254),a

	ld bc,0x7ffd
	ld a,0x1f
	out (c),a

	macro copy0, from, to
		copy from,to
		if defined pentagon
  		ld bc,07ffdh ; for pentagon
  		ld a,017h
  		out (c),a
		else
      nop    ; for 128 / scorpion
      ld a,0x57
      out (0xfd),a
    endif
	endm

	macro copy1, from, to
		copy from,to
		if defined pentagon
  		ld bc,07ffdh ; for pentagon
  		ld a,01fh
  		out (c),a
    else
      nop    ; for 128 / scorpion
      ld a,0x5f
      out (0xfd),a
    endif
	endm
	
	; for scorpion: nop / ld a,0x57 (or 0x5f) / out (fd),a

	macro copy, from, to
    if defined pentagon
  		add hl,hl ; pentagon only
  	endif
		ld sp,from
		pop af	
		pop bc	
		pop de	
		pop hl	
		exx	
		ex af,af'	
		pop af	
		pop bc	
		pop de	
		pop hl	
		ld sp,to+0x0010
		push hl	
		push de	
		push bc	
		push af	
		exx	
		ex af,af'	
		push hl	
		push de	
		push bc	
		push af	
		ld sp,from+0x0010
		pop af	
		pop bc	
		pop de	
		pop hl	
		exx	
		ex af,af'	
		pop af	
		pop bc	
		pop de	
		pop hl	
		ld sp,to+0x0020
		push hl	
		push de	
		push bc	
		push af	
		exx	
		ex af,af'	
		push hl	
		push de	
		push bc	
		push af
	endm

	copy0 attrdata+0x0000, 0x5800
	copy1 attrdata+0x0020, 0xd800
	copy0 attrdata+0x0040, 0x5800
	copy1 attrdata+0x0060, 0xd800
	copy0 attrdata+0x0080, 0x5820
	copy1 attrdata+0x00a0, 0xd820
	copy0 attrdata+0x00c0, 0x5820
	copy1 attrdata+0x00e0, 0xd820

	copy0 attrdata+0x0100, 0x5840
	copy1 attrdata+0x0120, 0xd840
	copy0 attrdata+0x0140, 0x5840
	copy1 attrdata+0x0160, 0xd840
	copy0 attrdata+0x0180, 0x5860
	copy1 attrdata+0x01a0, 0xd860
	copy0 attrdata+0x01c0, 0x5860
	copy1 attrdata+0x01e0, 0xd860

	copy0 attrdata+0x0200, 0x5880
	copy1 attrdata+0x0220, 0xd880
	copy0 attrdata+0x0240, 0x5880
	copy1 attrdata+0x0260, 0xd880
	copy0 attrdata+0x0280, 0x58a0
	copy1 attrdata+0x02a0, 0xd8a0
	copy0 attrdata+0x02c0, 0x58a0
	copy1 attrdata+0x02e0, 0xd8a0

	copy0 attrdata+0x0300, 0x58c0
	copy1 attrdata+0x0320, 0xd8c0
	copy0 attrdata+0x0340, 0x58c0
	copy1 attrdata+0x0360, 0xd8c0
	copy0 attrdata+0x0380, 0x58e0
	copy1 attrdata+0x03a0, 0xd8e0
	copy0 attrdata+0x03c0, 0x58e0
	copy1 attrdata+0x03e0, 0xd8e0

	copy0 attrdata+0x0400, 0x5900
	copy1 attrdata+0x0420, 0xd900
	copy0 attrdata+0x0440, 0x5900
	copy1 attrdata+0x0460, 0xd900
	copy0 attrdata+0x0480, 0x5920
	copy1 attrdata+0x04a0, 0xd920
	copy0 attrdata+0x04c0, 0x5920
	copy1 attrdata+0x04e0, 0xd920

	copy0 attrdata+0x0500, 0x5940
	copy1 attrdata+0x0520, 0xd940
	copy0 attrdata+0x0540, 0x5940
	copy1 attrdata+0x0560, 0xd940
	copy0 attrdata+0x0580, 0x5960
	copy1 attrdata+0x05a0, 0xd960
	copy0 attrdata+0x05c0, 0x5960
	copy1 attrdata+0x05e0, 0xd960

	copy0 attrdata+0x0600, 0x5980
	copy1 attrdata+0x0620, 0xd980
	copy0 attrdata+0x0640, 0x5980
	copy1 attrdata+0x0660, 0xd980
	copy0 attrdata+0x0680, 0x59a0
	copy1 attrdata+0x06a0, 0xd9a0
	copy0 attrdata+0x06c0, 0x59a0
	copy1 attrdata+0x06e0, 0xd9a0

	copy0 attrdata+0x0700, 0x59c0
	copy1 attrdata+0x0720, 0xd9c0
	copy0 attrdata+0x0740, 0x59c0
	copy1 attrdata+0x0760, 0xd9c0
	copy0 attrdata+0x0780, 0x59e0
	copy1 attrdata+0x07a0, 0xd9e0
	copy0 attrdata+0x07c0, 0x59e0
	copy1 attrdata+0x07e0, 0xd9e0

	copy0 attrdata+0x0800, 0x5a00
	copy1 attrdata+0x0820, 0xda00
	copy0 attrdata+0x0840, 0x5a00
	copy1 attrdata+0x0860, 0xda00
	copy0 attrdata+0x0880, 0x5a20
	copy1 attrdata+0x08a0, 0xda20
	copy0 attrdata+0x08c0, 0x5a20
	copy1 attrdata+0x08e0, 0xda20

	copy0 attrdata+0x0900, 0x5a40
	copy1 attrdata+0x0920, 0xda40
	copy0 attrdata+0x0940, 0x5a40
	copy1 attrdata+0x0960, 0xda40
	copy0 attrdata+0x0980, 0x5a60
	copy1 attrdata+0x09a0, 0xda60
	copy0 attrdata+0x09c0, 0x5a60
	copy1 attrdata+0x09e0, 0xda60

	copy0 attrdata+0x0a00, 0x5a80
	copy1 attrdata+0x0a20, 0xda80
	copy0 attrdata+0x0a40, 0x5a80
	copy1 attrdata+0x0a60, 0xda80
	copy0 attrdata+0x0a80, 0x5aa0
	copy1 attrdata+0x0aa0, 0xdaa0
	copy0 attrdata+0x0ac0, 0x5aa0
	copy1 attrdata+0x0ae0, 0xdaa0

	copy0 attrdata+0x0b00, 0x5ac0
	copy1 attrdata+0x0b20, 0xdac0
	copy0 attrdata+0x0b40, 0x5ac0
	copy1 attrdata+0x0b60, 0xdac0
	copy0 attrdata+0x0b80, 0x5ae0
	copy1 attrdata+0x0ba0, 0xdae0
	copy0 attrdata+0x0bc0, 0x5ae0
	copy1 attrdata+0x0be0, 0xdae0

sp_back:
	ld sp,0
	ld a,0x00	; border black
	out (0xfe),a
	ret	
