#!/usr/bin/ruby -w

require 'rubygems'
require 'active_support'
include ActiveSupport::CoreExtensions::Array::Grouping

# generate a list of the numbers 0..767 in partly randomized order

numbers = (0..767).to_a

numbers.each_index do |i|
  min = [0,i-127].max
  max = [767,i+127].min
  swap = rand(max+1-min)+min
  numbers[i],numbers[swap] = numbers[swap],numbers[i]
end

numbers.reverse!

numbers.in_groups_of(16) do |grp|
  puts "\tdw #{grp.join(',')}"
end