#!/usr/bin/ruby

# sinewave generator

amplitude = ARGV.shift.to_f
origin = ARGV.shift.to_f
preshift = (ARGV.shift || 1).to_i

sine = []

0.upto(255) do |i|
	sine[i] = (amplitude * Math.sin(i * Math::PI / 128) + origin).to_i * preshift
end

0.step(255, 16) do |i|
	puts "\tdb #{sine[i..i+15].join ', '}"
end