#!/usr/bin/ruby

# cosinewave generator

amplitude = ARGV.shift.to_f
origin = ARGV.shift.to_f
preshift = (ARGV.shift || 1).to_i

cosine = []

0.upto(127) do |i|
	cosine[i] = (amplitude * Math.cos(i * Math::PI / 128) + origin).to_i * preshift
end

0.step(127, 16) do |i|
	puts "\tdb #{cosine[i..i+15].join ', '}"
end